# -*- coding: utf-8 -*-

import xbmcaddon, xbmc, uservar, sys, os, time
import wizard as adrnew
KODIV          = float(xbmc.getInfoLabel("System.BuildVersion")[:4])
if KODIV > 17:
	import zfile as zipfile #FTG mod for Kodi 18
else:
	import zipfile

ADDON_ID       = uservar.ADDON_ID
ADDONTITLE     = uservar.ADDONTITLE
COLOR1         = uservar.COLOR1
COLOR2         = uservar.COLOR2
ADDON          = adrnew.addonId(ADDON_ID)
HOME           = xbmc.translatePath('special://home/')
USERDATA       = os.path.join(HOME,      'userdata')
GUISETTINGS    = os.path.join(USERDATA,  'guisettings.xml')
KEEPFAVS       = adrnew.getS('keepfavourites')
KEEPSOURCES    = adrnew.getS('keepsources')
KEEPPROFILES   = adrnew.getS('keepprofiles')
KEEPADVANCED   = adrnew.getS('keepadvanced')
KEEPSUPER      = adrnew.getS('keepsuper')
KEEPREPOS      = adrnew.getS('keeprepos')
KEEPWHITELIST  = adrnew.getS('keepwhitelist')
KODIV          = float(xbmc.getInfoLabel("System.BuildVersion")[:4])
LOGFILES       = ['xbmc.log', 'xbmc.old.log', 'kodi.log', 'kodi.old.log', 'spmc.log', 'spmc.old.log', 'tvmc.log', 'tvmc.old.log', 'Thumbs.db', '.gitignore', '.DS_Store']
bad_files      = ['cache.db', 'DEATHScache.db', 'DEATHScache.db-shm', 'DEATHScache.db-wal', 'DSRDcache.db', 'DSRDcache.db-shm', 'DSRDcache.db-wal', 'queue.db', 'commoncache.db', 'access.log', 'trakt.db', 'video_cache.db']

def all(_in, _out, dp=None, ignore=None, title=None):
	if dp: return allWithProgress(_in, _out, dp, ignore, title)
	else: return allNoProgress(_in, _out, ignore)

def allNoProgress(_in, _out, ignore):
	try:
		zin = zipfile.ZipFile(_in, 'r')
		zin.extractall(_out)
	except Exception, e:
		print str(e)
		return False
	return True

def allWithProgress(_in, _out, dp, ignore, title):
	count = 0; errors = 0; error = ''; update = 0; size = 0; excludes = []
	try:
		zin = zipfile.ZipFile(_in,  'r')
	except Exception, e:
		errors += 1; error += '%s\n' % e
		adrnew.log('[B]Erro ao verificar[/B] .zip: %s' % str(e), xbmc.LOGERROR)
		return update, errors, error
	
	whitelist = adrnew.whiteList('read')
	for item in whitelist:
		try: name, id, fold = item
		except: pass
		excludes.append(fold)
		if fold.startswith('pvr'):
			adrnew.setS('pvrclient', id)
	
	nFiles = float(len(zin.namelist()))
	zipsize = adrnew.convertSize(sum([item.file_size for item in zin.infolist()]))

	zipit = str(_in).replace('\\', '/').split('/')
	title = title if not title == None else zipit[-1].replace('.zip', '')

	for item in zin.infolist():
		count += 1; prog = int(count / nFiles * 100); size += item.file_size
		file = str(item.filename).split('/')
		skip = False
		line1  = '[COLOR skyblue][B]ART[/B]/[B]Buil[/B]: %s[COLOR skyblue] - [/COLOR][COLOR skyblue]Erros: [B]%s[/B][/COLOR]' % (title, errors)
		line2  = '[COLOR skyblue][B]Arquivos[/B]: [/COLOR][COLOR skyblue][B]%s[/B]/[B]%s[/B][/COLOR] ' % (count, int(nFiles))
		line2 += '[COLOR skyblue]- [B]Tamanho[/B]: [/COLOR][COLOR skyblue][B]%s[/B]/[B]%s[/B][/COLOR]' % (adrnew.convertSize(size), zipsize)
		line3  = '[COLOR skyblue][B]Extraindo[/B]:[/COLOR][COLOR skyblue]/%s[/COLOR]' % (item.filename)
		if item.filename == 'userdata/sources.xml' and KEEPSOURCES == 'true': skip = True
		elif item.filename == 'userdata/favourites.xml' and KEEPFAVS == 'true': skip = True
		elif item.filename == 'userdata/profiles.xml' and KEEPPROFILES == 'true': skip = True
		elif item.filename == 'userdata/advancedsettings.xml' and KEEPADVANCED == 'true': skip = True
		elif file[0] == 'addons' and file[1] in excludes: skip = True
		elif file[0] == 'userdata' and file[1] == 'addon_data' and file[2] in excludes: skip = True
		elif file[-1] in LOGFILES: skip = True
		elif file[-1] in bad_files: skip = True
		elif file[-1].endswith('.csv'): skip = True
		elif not str(item.filename).find('plugin.program.super.favourites') == -1 and KEEPSUPER == 'true': skip = True
		elif not str(item.filename).find(ADDON_ID) == -1 and ignore == None: skip = True
		if skip == True: adrnew.log("[B]Ignorado[/B]: %s" % item.filename, xbmc.LOGNOTICE)
		else:
			try:
				zin.extract(item, _out)
			except Exception, e:
				errormsg  = "[COLOR %s][B]Arquivo[/B]:[/COLOR][COLOR %s] %s[/COLOR]\n" % (COLOR2, COLOR1, file[-1])
				errormsg += "[COLOR %s][B]Pasta[/B]:[/COLOR][COLOR %s] %s[/COLOR]\n" % (COLOR2, COLOR1, (item.filename).replace(file[-1],''))
				errormsg += "[COLOR %s][B]Erro[/B]:[/COLOR][COLOR %s] %s[/COLOR]\n\n" % (COLOR2, COLOR1, str(e).replace('\\\\','\\').replace("'%s'" % item.filename, ''))
				errors += 1; error += errormsg
				adrnew.log('[B]Erro ao extrair[/B]: %s(%s)' % (item.filename, str(e)), xbmc.LOGERROR)
				pass
		dp.update(prog, line1, line2, line3)
		if dp.iscanceled(): break
	if dp.iscanceled(): 
		dp.close()
		adrnew.LogNotify("[COLOR %s]%s[/COLOR]" % (COLOR1, ADDONTITLE), "[COLOR %s]Extração cancelado![/COLOR]" % COLOR2)
		sys.exit()
	return prog, errors, error